#include "eeprom.h"
#include "iic.h"

//IIC豸CPUȷ豸ַȻͨӦж豸Ƿ
uint8_t EEPROM_Device_Check(uint8_t Address)
{
    uint8_t ACKValue;

    IIC_Start();                           //ʼź

    IIC_SendByte(Address|EEPROM_I2C_WR);   //豸ַԼд

    ACKValue = IIC_WaitAck();              //ȴӦź

    IIC_Stop();                            //ֹͣź

    return ACKValue;                       //ӦźŲӦźж豸Ƿ
}

//ȴEEPROM׼״̬дݺñ
//дʱʹI2Cݴ䵽EEPROMEEPROMڲռдҪһʱ䣬EEPROMڲдɺI2C豸ѰַӦñɵȴEEPROMڲʱд
uint8_t EEPROM_WaitStandby(void)
{
    uint32_t wait_count = 0;

    while(EEPROM_Device_Check(EEPROM_DEV_ADDR))
    {
        //ⳬ˳ѭ
        if(wait_count++>0xFFFF)
        {
            //ȴʱ
            return 1;
        }
    }
    //ȴ
    return 0;
}

//ӴEEPROMַָʼȡ
//ReadBuf:ŶݵĻָ     SAddress:ʼַ     Size:ݳȣλΪֽ
uint8_t EEPROM_ReadBytes(uint8_t *ReadBuf, uint16_t SAddress, uint16_t Size)
{
    uint16_t i;

    /* ôEEPROM漴ȡָУȡֽ */

    /* 1I2Cź */
    IIC_Start();

    /* 2ֽڣ7bitǵַbit0Ƕдλ0ʾд1ʾ */
    IIC_SendByte(EEPROM_DEV_ADDR | EEPROM_I2C_WR);  /* ˴дָ */

    /* 3ȴACK */
    if (IIC_WaitAck() != 0)
    {
        goto cmd_fail;  /* EEPROMӦ */
    }

    /* 4ֽڵַ24C02ֻ256ֽڣ1ֽھ͹ˣ24C04ϣô˴Ҫַ */
    IIC_SendByte((uint8_t)SAddress);

    /* 5ȴACK */
    if (IIC_WaitAck() != 0)
    {
        goto cmd_fail;  /* EEPROMӦ */
    }

    /* 6I2CߡǰĴĿEEPROM͵ַ濪ʼȡ */
    IIC_Start();

    /* 7ֽڣ7bitǵַbit0Ƕдλ0ʾд1ʾ */
    IIC_SendByte(EEPROM_DEV_ADDR | EEPROM_I2C_RD);  /* ˴Ƕָ */

    /* 8ACK */
    if (IIC_WaitAck() != 0)
    {
        goto cmd_fail;  /* EEPROMӦ */
    }

    /* 9ѭȡ */
    for (i = 0; i < Size; i++)
    {
        ReadBuf[i] = IIC_ReadByte();  /* 1ֽ */

        /* ÿ1ֽںҪAck һֽڲҪAckNack */
        if (i != Size - 1)
        {
            IIC_ACK();  /* мֽڶCPUACKź(SDA = 0) */
        }
        else
        {
            IIC_NACK(); /* 1ֽڶCPUNACKź(SDA = 1) */
        }
    }

    /* I2Cֹͣź */
    IIC_Stop();
    return 1;   /* ִгɹ */

cmd_fail: /* ִʧܺмǷֹͣźţӰI2C豸 */
    /* I2Cֹͣź */
    IIC_Stop();
    return 0;
}

//EEPROMַָдݣҳддЧ
//WriteBuf:ŶݵĻָ     SAddress:ʼַ     Size:ݳȣλΪֽ
uint8_t EEPROM_WriteBytes(uint8_t *WriteBuf, uint16_t SAddress, uint16_t Size)
{
    uint16_t i,m;
    uint16_t sAddr;

    /* дEEPROMȡֽܶڣÿдֻͬһpage
                   24xx02page size = 8
                   򵥵ĴΪֽдģʽÿд1ֽڣ͵ַ
                   ΪдЧ: page wirte
    */

    sAddr = SAddress;
    for (i = 0; i < Size; i++)
    {
        /* ͵1ֽڻҳ׵ַʱҪ·źź͵ַ */
        if ((i == 0) || (sAddr & (EEPROM_PAGE_SIZE - 1)) == 0)
        {
            /*0ֹͣźţڲд*/
            IIC_Stop();

            /*
                                        ͨӦķʽжڲдǷ,һС 10ms
               CLKƵΪ200KHzʱѯΪ30
                                        ԭͬ EEPROM_WaitStandby úɺֹͣźţڴ˴
            */

            for (m = 0; m < 1000; m++)
            {
                /* 1I2Cź */
                IIC_Start();

                /* 2ֽڣ7bitǵַbit0Ƕдλ0ʾд1ʾ */
                IIC_SendByte(EEPROM_DEV_ADDR | EEPROM_I2C_WR);  /* ˴дָ */

                /* 3һʱӣжǷȷӦ */
                if (IIC_WaitAck() == 0)
                {
                    break;
                }
            }
            if (m  == 1000)
            {
                goto cmd_fail;  /* EEPROMдʱ */
            }

            /* 4ֽڵַ24C02ֻ256ֽڣ1ֽھ͹ˣ24C04ϣô˴Ҫַ */
            IIC_SendByte((uint8_t)sAddr);

            /* 5ȴACK */
            if (IIC_WaitAck() != 0)
            {
                goto cmd_fail;  /* EEPROMӦ */
            }
        }

        /* 6ʼд */
        IIC_SendByte(WriteBuf[i]);

        /* 7ACK */
        if (IIC_WaitAck() != 0)
        {
            goto cmd_fail;  /* EEPROMӦ */
        }

        sAddr++;   /* ַ1 */
    }

    /* ִгɹI2Cֹͣź */
    IIC_Stop();

    //ȴһEEPROMڲд
    if(EEPROM_WaitStandby() == 1) //1ʾʱ
    goto cmd_fail;

    return 1;

cmd_fail: /* ִʧܺмǷֹͣźţӰI2C豸 */
    /* I2Cֹͣź */
    IIC_Stop();
    return 0;
}

void EEPROM_Erase(void)
{
    uint16_t i;
    uint8_t buf[EEPROM_SIZE];

    /* 仺 */
    for (i = 0; i < EEPROM_SIZE; i++)
    {
        buf[i] = 0xFF;
    }

    /* дEEPROM, ʼַ = 0ݳΪ 256 */
    if (EEPROM_WriteBytes(buf, 0, EEPROM_SIZE) == 0)
    {
        printf("eeprom\r\n");
        return;
    }
    else
    {
        printf("eepromɹ\r\n");
    }
}

/*
 * EEPROM AT24C02 д
   *   1쳣0
*/
uint8_t EEPROM_Test(void)
{
  uint16_t i;
  uint8_t write_buf[EEPROM_SIZE];
  uint8_t read_buf[EEPROM_SIZE];

/*-----------------------------------------------------------------------------------*/
  if (EEPROM_Device_Check(EEPROM_DEV_ADDR) == 1)
  {
        /* ûм⵽EEPROM */
        printf("ûм⵽EEPROM!\r\n");

        return 0;
  }

/*------------------------------------------------------------------------------------*/
  /* Ի */
  for (i = 0; i < EEPROM_SIZE; i++)
  {
        write_buf[i] = i;
  }

/*------------------------------------------------------------------------------------*/
  if (EEPROM_WriteBytes(write_buf, 0, EEPROM_SIZE) == 0)
  {
        printf("дeeprom\r\n");
        return 0;
  }
  else
  {
        printf("дeepromɹ\r\n");
  }

/*-----------------------------------------------------------------------------------*/
  if (EEPROM_ReadBytes(read_buf, 0, EEPROM_SIZE) == 0)
  {
        printf("eeprom\r\n");
        return 0;
  }
  else
  {
        printf("eepromɹ£\r\n");
  }

/*-----------------------------------------------------------------------------------*/
  for (i = 0; i < EEPROM_SIZE; i++)
  {
        if(read_buf[i] != write_buf[i])
        {
            printf("0x%02X ", read_buf[i]);
            printf(":EEPROMдݲһ");
            return 0;
        }

        printf(" %02X", read_buf[i]);

        if ((i & 15) == 15)
        {
            printf("\r\n");
        }
  }

  printf("eepromдԳɹ\r\n");
  return 1;
}










